

void drawAudio(){
  
    // draw audio in controls
  colorMode(RGB);
  stroke(255, 150);
  strokeWeight(1);
  noFill();
  rect(width-40, height-20, width-20, height*0.6);
  stroke(255, 200);
  line(width-40, height-20-triggerVol, width-20, height-20-triggerVol);
  fill(255, 200);
  ellipse(width-40, height-20-triggerVol, 3, 3);
  ellipse(width-20, height-20-triggerVol, 3, 3);
  noStroke();

  pushMatrix();
  translate(width-26, height-220);
  rotate(-PI*0.5);
  text("trigger volume", -80, 0);
  text("average volume", -80, -30);
  popMatrix();

  // changes the colour of the volume gauge if there has been a clap
  if (claps.size() > 0) {
    fill(0, 255, 200, 100 + claps.size()*20);
  }
  else {
    fill(0, 200, 255, 100);
  }
  rect(width-40, height-20, width-20, height-30-(abs(in.left.get(1))+in.right.get(1))*volumeScale);
  for (int i = 0; i < 200; i++) {
    randomSeed(i);
    if ((abs(in.left.get(i))*volumeScale > triggerVol || abs(in.right.get(i))*volumeScale > triggerVol) && !clapped) {
      sT = 0;
      clapped = true;
      claps.add(new Clap(random(xSize), random(ySize)));
    }
  }


  // calculate and draw average volume
  // collects a moving average of 100 samples updated every 5 second

  float tempAverage = 0;
  float count = 0;
  for (int i = 0; i < 400; i+=20) {
    tempAverage += abs(in.left.get(i))*volumeScale;
    count+=1;
  }
  tempAverage /= count;
  if (sampleCount == numSamples) sampleCount = 0;
  if (longT%100 == 0) {
    aveSamples[sampleCount] = tempAverage;
    sampleCount++;
  }

  aveVol = 0;
  for (int i = 0; i < numSamples; i++) {
    aveVol += aveSamples[i];
  }
  aveVol /= float(numSamples);
  
  aveVol += volumeBoost;


  stroke(255, 150);
  noFill();
  rect(width-70, height-20, width-50, height*0.6);
  noStroke();
  fill(0, 255, 100, 100);
  rect(width-70, height-20, width-50, height-30-abs(aveVol));

}
