

void keyPressed() {

  if (key == 's') {
    speedSet = !speedSet;
    if (speedSet) DMXmaxSpeed = 120;
    if (!speedSet) DMXmaxSpeed = 0;

    cp5.getController("DMXmaxSpeed").setValue(DMXmaxSpeed);

    //    for (int i = 0; i < 42; i++) {
    //      dmxHeight.setDMXChannel( i*7 + 2, DMXmaxSpeed);
    //    }
  }
  if (key == 'd') {
    sendDMX = !sendDMX;
    cp5.getController("sendDMX").setValue(sendDMX?1:0);
  }

  if (key == 'a') {
    animate = !animate;
    cp5.getController("animate").setValue(animate?1:0);
  }

  if (key == '=') timeSpeed += 0.005;
  if (key == '-') timeSpeed -= 0.005;

  if (key == 'p') drawing = !drawing;

  if (key == 'c') claps.add(new Clap(3.5, 3));

  if (key == 'r' && sendDMX && !resetting) {
    animate = false;
    resetting = true;
    reset();
  }
  if (key == 't' && sendDMX && resetting) {
    resetting = false;
    resetT = 0;
    animate = true;

    for (int x = 0; x < xSize; x++) {
      for (int y = 0; y < ySize; y++) {

        int hChannel = (x+y*xSize)*7;

        // cancel the up channel to complete the reset
        //dmxHeight.setDMXChannel(hChannel+5, 0);
      }
    }
  }
}



void controlEvent(ControlEvent theEvent) {


  if (theEvent.isController()) {
    if (theEvent.getController().getName().equals("DMXmaxSpeed")) {
      for (int i = 0; i < 42; i++) {
        //dmxHeight.setDMXChannel( i*7 + 2, DMXmaxSpeed);
      }
    }


  } 
  else if (theEvent.isGroup()) {
    if (theEvent.group().name() == "ColorMode") {
      colorMode = (int)theEvent.getGroup().getValue();
      changing = true;
      cT = 0;
      for (int i = 0; i < xSize; i++) {
        for (int j = 0; j < ySize; j++) {
          tempC[i][j] = ballC[i][j];
        }
      }
    }
  }
}


// sets up the GUI sliders and buttons

void setupControl() {

  gp1 = cp5.addGroup("Animation")
    .setBackgroundColor(color(0, 100))
      .setBackgroundHeight(120)
        ;

  gp2 = cp5.addGroup("Wave Parameters")
    .setBackgroundColor(color(0, 100))
      .setBackgroundHeight(140)
        ;  

  gp3 = cp5.addGroup("RGB Lights")
    .setBackgroundColor(color(0, 100))
      .setBackgroundHeight(150)
        ;     

  // group 1

  cp5.addSlider("timeSpeed")
    .setPosition(20, 20)
      .setSize(200, 15)
        .setRange(0, 0.01)
          .setValue(0.003)
            .moveTo(gp1)
              ;  

  cp5.addSlider("DMXmaxSpeed")
    .setPosition(20, 40)
      .setSize(200, 15)
        .setRange(0, 255)
          .setValue(120)
            .moveTo(gp1)
              ;  

  cp5.addSlider("x")
    .setPosition(900, 470)
      .setSize(200, 5)
        .setRange(-PI, PI)
          .setValue(1.41)
            .moveTo(gp1)
              ; 
  cp5.addSlider("y")
    .setPosition(900, 480)
      .setSize(200, 5)
        .setRange(-PI, PI)
          .setValue(0)
            .moveTo(gp1)
              ;  
  cp5.addSlider("z")
    .setPosition(900, 490)
      .setSize(200, 5)
        .setRange(0, PI)
          .setValue(0.83)
            .moveTo(gp1)
              ;  
  cp5.addSlider("tx")
    .setPosition(900, 500)
      .setSize(200, 5)
        .setRange(600, 1400)
          .setValue(1200)
            .moveTo(gp1)
              ;  
  cp5.addSlider("ty")
    .setPosition(900, 510)
      .setSize(200, 5)
        .setRange(0, 1000)
          .setValue(710)
            .moveTo(gp1)
              ;   
  cp5.addSlider("tz")
    .setPosition(900, 520)
      .setSize(200, 5)
        .setRange(-2000, 0)
          .setValue(-1780)
            .moveTo(gp1)
              ;  



  cp5.addToggle("waveNoise")
    .setLabel("wave/noise")
      .setPosition(20, 70)
        .setSize(20, 15)
          .setValue(true)
            .setMode(ControlP5.SWITCH)
              .moveTo(gp1);



  cp5.addToggle("animate")
    .setPosition(110, 70)
      .setSize(20, 15)
        .setValue(true)
          .setMode(ControlP5.SWITCH)
            .moveTo(gp1);

  cp5.addToggle("sendDMX")
    .setPosition(180, 70)
      .setSize(20, 15)
        .setValue(true)
          .setMode(ControlP5.SWITCH)
            .moveTo(gp1);



  // group 2

  cp5.addSlider("ampMultiplier")
    .setPosition(20, 20)
      .setSize(200, 15)
        .setRange(0, 1)
          .setValue(0.7)
            .moveTo(gp2)
              ;  

  cp5.addSlider("freqMultiplier")
    .setPosition(20, 40)
      .setSize(200, 15)
        .setRange(0, 2)
          .setValue(1)
            .moveTo(gp2)
              ;  

  cp5.addSlider("heightOffset")
    .setPosition(20, 60)
      .setSize(200, 15)
        .setRange(-200, 200)
          .setValue(0)
            .moveTo(gp2)
              ;  

  cp5.addSlider("volumeScale")
    .setPosition(900, 280)
      .setSize(200, 10)
        .setRange(700, 1400)
          .setValue(0)
            .moveTo(gp2)
              ;  

  cp5.addSlider("volumeBoost")
    .setPosition(900, 300)
      .setSize(200, 10)
        .setRange(0, 20)
          .setValue(0)
            .moveTo(gp2)
              ;  

  cp5.addSlider("extraNoise")
    .setPosition(20, 100)
      .setSize(200, 15)
        .setRange(0, 1)
          .setValue(0)
            .moveTo(gp2)
              ; 



  // group 3

  cp1 = cp5.addColorPicker("Colour1", 10, 45, 255, 10)
    .moveTo(gp3)  
      .setColorValue(color(255, 0, 0));

  cp2 = cp5.addColorPicker("Colour2", 10, 120, 255, 10)
    .moveTo(gp3)  
      .setColorValue(color(255, 255, 0)); 

  cp5.addRadioButton("ColorMode")
    .setPosition(10, 10)
      .setSize(15, 15)
        .setColorForeground(color(120))
          .setColorActive(color(255))
            .setColorLabel(color(255))
              .setItemsPerRow(3)
                .setSpacingColumn(75)
                  .addItem("Manual", 1)
                    .addItem("VolumeColours", 2)
                      .addItem("Daily", 3)
                        .activate(2)
                          .moveTo(gp3)
                            ;        

  accordion = cp5.addAccordion("acc")
    .setPosition(20, height-610)
      .setWidth(250)
        .addItem(gp1)
          .addItem(gp2)
            .addItem(gp3)

              ;

  accordion.open(0, 1, 2);
  accordion.setCollapseMode(Accordion.MULTI);
}





void mousePressed() {
  if (mouseX > width-45 && mouseX < width-15 && mouseY < height-20 && mouseY > height*0.6) {
    triggerVol = height - mouseY - 20;
  }
}

void mouseDragged() {
  if (mouseX > width-45 && mouseX < width-15 && mouseY < height-20 && mouseY > height*0.6) {
    triggerVol = height - mouseY - 20;
  }
}

