
void drawGUI() {


  // display time
  fill(255);
  textFont(timeFont);
  textSize(60);
  String min = minute()>=10 ? "" : "0";
  text(hour() + " : " + min+ minute(), 60, 80);
  textFont(font);
  textSize(13);


  //draw dayGradients
  pushMatrix();
  translate(40, 620);
  fill(255);
  text("Day Gradients", 0, -20);
  noStroke();
  rectMode(CENTER);
  for (float i = 0; i < 1; i+=0.02) {
    fill(day1.getGradient(i));
    rect(i*240, 0, 10, 10);
  }
  for (float i = 0; i < 1; i+=0.02) {
    fill(day2.getGradient(i));
    rect(i*240, 20, 10, 10);
  }
  rectMode(CORNERS);

  stroke(255, 100);
  strokeWeight(1);
  for (int i = 0; i < 240; i+= 240/13) {
    line(i, -5, i, 25);
  }
  stroke(255);
  strokeWeight(2);
  float timeVal = constrain(map(hour()+minute()*0.016, 8, 21, 0, 240), 0, 240);
  line(timeVal, -10, timeVal, 30);
  popMatrix();



  // grey glass
  //  fill(0, 100);
  //  rect(0, height*0.6, width, height);


  // right side text
  fill(255);
  if (sendDMX) {
    text("DMX sending", width-100, 50);
  }
  else {
    text ("DMX Paused", width-100, 50);
  }

  if (animate) {
    text("Animated", width-100, 80);
  }
  else {
    text("Paused", width-100, 80);
  }


  pushMatrix();
  translate(300, height - 600);
  boolean over = false;
  for (int x = 0; x < xSize; x++) {
    for (int y = 0; y < ySize; y++) {
      if (ballZ[x][y] > 255 || ballZ[x][y]<0) over = true;
      text(allBallZ[x+7*y], 250+50*x, 380+30*y);
     
    }
  }
  pushStyle();
  fill(255);
  if (over) text("EXCEEDED!!!!", 50, 100);
  popStyle();

  text("Amp1 = " + floor(amp1*100)*0.01, 50, 380);
  text("Amp2 = " + floor(amp2*100)*0.01, 50, 400);
  text("Freq1 = " + floor(freq1*100)*0.01, 50, 420);
  text("Freq1 = " + floor(freq2*100)*0.01, 50, 440);

  text("Time Speed = " + timeSpeed, 50, 480);

  text("DMX speed = " + DMXmaxSpeed, 50, 500);


  text("Average VOl = " + round(aveVol*100)*0.01, 50, 530);

  popMatrix();

  cp5.draw();

}

