
// this tab houses all the gradient controls for daily colour interpolation

class Gradient
{
  ArrayList colors;
   
  // Constructor
  Gradient()
  {
    colors = new ArrayList();
  }
   
  void addColor(color c)
  {
    colors.add(c);
  }
   
  color getGradient(float value)
  {
    value = map(value,0,1,0,colors.size());
    
    // make sure there are colors to use
    if(colors.size() == 0)
      return #000000;
     
    // if its too low, use the lowest value
    if(value <= 0.0)
      return (color)(Integer) colors.get(0);
     
    // if its too high, use the highest value
    if(value >= colors.size() - 1)
      return (color)(Integer) colors.get(colors.size() -  1);
     
    // lerp between the two needed colors
    int color_index = (int)value;
    color c1 = (color)(Integer) colors.get(color_index);
    color c2 = (color)(Integer) colors.get(color_index + 1);
     
    return lerpColor(c1, c2, value - color_index);
  }
}

void setupGradient(){
  grad.addColor(color(50));
  grad.addColor(color(102, 0, 102));
  grad.addColor(color(0, 144, 255));
  grad.addColor(color(0, 255, 207));
  grad.addColor(color(51, 204, 102));
  grad.addColor(color(111, 255, 0));
  grad.addColor(color(191, 255, 0));
  grad.addColor(color(255, 240, 0));
  grad.addColor(color(255, 153, 102));
  grad.addColor(color(204, 51, 0));
  grad.addColor(color(153, 0, 0));
  
  day1.addColor(color(123,185,254));
  day1.addColor(color(173,235,254));
  day1.addColor(color(242,255,49));
  day1.addColor(color(242,151,39));
  day1.addColor(color(217,85,37));
  day1.addColor(color(166,36,36));
  
  day2.addColor(color(74,0,180));
  day2.addColor(color(123,185,254));
  day2.addColor(color(0,255,0));
//  day2.addColor(color(173,235,254));
  day2.addColor(color(242,255,49));
  day2.addColor(color(242,151,39));



}
